#include <stdio.h>
#include <math.h>


int main()
{
   long long int n,m;
   long long int i;
   long long int b[100000],a[100000];
   long long int x=0;
     long long int c;
   long long int s=0;
     scanf("%lld",&n);
       scanf("%lld",&m);
   for(i=1;i<=m;i++)
   {
       scanf("%lld",&b[i]);
       
   }
   scanf("%lld",&c);
   a[0]=0;
   for(i=1;i<=n;i++)
   {
       a[i]=a[i-1]+1;
       
   }
   for(i=0;i<n-m;i++)
   {
       for (int j=1; j<=m; j++)
  a[i + b[j]] = a[i + j];
      
   }
   
   for(i=1;i<n;i++)
   {
        
       s=pow(c,i)*a[i];
       x=x+s;
       
       
   }
   printf("%lld",x);
   
}